#!/usr/bin/env python

import guestfs
import os
import json

pwd = "/"
config = "/tmp/integrity/cluster.vms"
searchdir = "/var/lib/stateless/writable/rhev/data-center/mnt/blockSD/"

def guestfs_check(full_path):
        print("\tTrying to open {0}".format(full_path))
        status = False
        try:
                g = guestfs.GuestFS()
                g.add_drive_opts(full_path, readonly = 1)
                g.launch()
        except Exception,e:
                print(u"\t\tguestfs refused to launch: {0}".format(e))
        else:
                status = True
                print(u"\t\tguestfs succesfully launched")
                print(u"\t\t\tPhysical volumes: {0}".format(g.pvs()))
                print(u"\t\t\tLogical volumes: {0}".format(g.lvs()))
                print(u"\t\t\tPartitions: {0}".format(g.list_partitions()))
                os = g.inspect_os()
                print(u"\t\t\tOperating systems: {0}".format(os))
                if os.__len__() == 1:
                        raw_mps = g.inspect_get_mountpoints(os[0])
                        print(u"\t\t\tMount points: {0}".format(raw_mps))
                        sorted_mps = sorted(raw_mps, key = lambda toup: (toup[0].__len__()))
                        for mp in sorted_mps:
                                print(u"\t\t\tDevice {1} is being mounted to {0}".format(mp[0], mp[1]))
                                try:
                                        g.mount_ro(mp[1], mp[0])
                                except Exception, e:
                                        print(u"\t\t\t\tMounting error: {0}".format(e))
                                        status = False
                                else:
                                        print(u"\t\t\t\tSuccesfully mounted")
                                finally:
                                        g.umount_all()

        finally:
                g.shutdown()
                g.close()
                return status

def search(vms):
        counter = 1
        for vm in vms:
                disk_image_id = vm["disk_image_id"]
                vm_name = vm["vm"]
                print("\n-------------------------------------------------------  {0}  ---------------------------------------------------------------------".format(counter))
                print("VM: '{0}' - disk_image_id: {1}".format(vm_name, disk_image_id))

if __name__ == "__main__":
        with open(config, "r") as f:
                vms = json.load(f)
        os.chdir(pwd)
        search(vms)

